# -*- Mode: cperl -*-

use Test::More tests => 3;

use Win32::Socketpair 'winsocketpair', 'winopen2';
ok(1, "loaded");

alarm 60;

my $data;

{ local $/; $data = <DATA> }

my $in = $data;
my $out = '';
my $mid = '';
my $mid_done;

my ($here, $there) = winsocketpair;

my $true = 1;
ioctl( $here, 0x8004667e, \$true );
ioctl( $there, 0x8004667e, \$true );

while (1) {
    my $vin = '';
    vec($vin, fileno $there, 1) = 1 unless $mid_done;
    vec($vin, fileno $here, 1) = 1;

    my $vout = '';
    vec($vout, fileno $here, 1) = 1 if length $in;
    vec($vout, fileno $there, 1) = 1 if length $mid;

    if (select($vin, $vout, undef, undef) > 0) {
    if (vec($vin, fileno $there, 1)) {
        unless (sysread($there, $mid, 20, length $mid)) {
        $mid_done = 1;
        shutdown($there, 1) unless length $mid;
        }
    }
    if (vec($vin, fileno $here, 1)) {
        sysread($here, $out, 1037, length $out)
        or last;
    }
    if (vec($vout, fileno $here, 1)) {
        my $written = syswrite($here, $in, 980);
        last unless $written;
        substr($in, 0, $written, '');
        shutdown($here, 1) unless length $in;
    }
    if (vec($vout, fileno $there, 1)) {
        my $written = syswrite($there, $mid, 1356);
        last unless $written;
        substr($mid, 0, $written, '');
        shutdown($there, 1) if (!length $mid and $mid_done);
    }
    }
}

is ($mid, "", "mid empty");
is ($out, $data, "transfer");

=disabled until I work out why it doesn't work.

my ($pid, $socket) = winopen2("more");
ok($pid, "winopen2 pid");
ok(fileno($socket), "winopen2 socket");
binmode($socket);
ioctl( $socket, 0x8004667e, \$true );

$in = $data;
$out = "";

while(1) {
    my $v = '';
    vec($v, fileno $socket, 1) = 1;

    my $vout = length $in ? $v : "";
    my $vin = $v;

    if (select($vin, $vout, undef, undef) > 0) {
    if (vec($vin, fileno($socket), 1)) {
        sysread($socket, $out, 30, length $out)
        or last;
    }
    if (vec($vout, fileno($socket), 1)) {
        my $written = syswrite($socket, $in, 5000)
        or last;
        substr($in, 0, $written, "");
        shutdown($socket, 1) unless length $in;
    }
    }
}
$out =~ s/[^a-z]//sg;
$data =~ s/[^a-z]//sg;
is($out, $data, "open2 more");
=cut

alarm 0;

0;
__DATA__


Rosala de Castro - Conto gallego

[Nota preliminar: Edicin digital a partir de Almanaque gallego... por
Manuel de Castro y Lpez, Buenos Aires, 1923, pp. 95-104, cotejada con
la edicin crtica de Mauro Armio (Obra completa, III, Madrid, Akal,
1980, pp. 517-530) y la de Manuel Arroyo Stephens (Obras completas,
II, Madrid, Fundacin Jos Antonio Castro, 1993, pp. 617-627).]


Un da de inverno  caer da tarde, dous amigos que eran amigos desde a
escola, e que contaban de anos o maldito nmero de tres veces dez,
camiaban a bon paso un sobre unha mula branca, gorda e de redondas
ancas, i outro encima dos seus ps, que non parecan asaarse das
pasadas lixeiras que lles faca dar seu dono.

O da pe corra tanto como o de acabalo, que vendo o sudor que lle
corra  seu compaeiro pola frente i as puntas dos cabelos, dxolle:

-E ti, Lourenzo, por que non mercas un come-toxos que te leve e te
traia por estes camios de Dios? Que esto de andar leguas a p por
montes e areales  bo prs cs.

-Come-toxos! Anda, e que os monten aqueles pra quens se fixeron, que
non  Lourenzo. Cabalo grande, ande ou non ande, e xa que grande non o
podo ter, sin l me quedo e srvome dos meus ps que nin beben, nin
comen, nin lle fan menester arreos.

-Verdade  que o teu modo de camiar  mis barato que ningn negro
de min!, que ora teo que pagar o portasgo slo porque vou en besta, e
non coma ti, nestes ps que Dios me dou. Pro... as coma as, gusto de
andar as xornadas en pernas alleas pra que as de un non cansen, e xa o
dixen: debas mercar un farroupeiro pra o teu descanso. Mais ti fas
coma o outro: hoxe o gano, hoxe o como, que man Dios dir. Nin tes
arrello nin cousa que o valla; gstanche os birbirichos i as
birbiricheiras, o vio do Ribeiro e as ostras do Carril. Lourenzo!,
debas casarte que  fin o tempo vai andando, os anos corren, e un
probe de un home faise vello e crbese de pelos brancos antes de que
poida ter manta na cama e aforrar pra unha ocasin; e esto, Lourenzo,
non se fai sin muller que tea man da casa e garde o dieiro que un
gana.

-Boi solto, ben se lambe.

-O vento! Esas sonche faladuras.  derradeiro, pra qu os homes
naceron si non  pra axuntarse cas mulleres, fillo da ta nai?
(Lourenzo tuse). Seica te costipache co reso da sern, malo de
ti. (Lourenzo volve a tusir). Lveme Dios si non  certo, e tanto non
tusiras si ora vieras a carranchaperna enriba de un farroupeiro.

-Costipado eu? Non o estiven na mia vida e penso que ora
tampouco. Pro... sempre que se me fala de casar dame unha tos
que... hem!... hem!... seica esto non  boa sial. Non cho parece,
Xan?

-O que me pars  que eres rabudo como as uvas do cacho, e eso venche
xa de nacenza, que non polo ben que te estimo deixo de conocer que
eres atravesado coma os cangrexos. Nin podo adiviar por que falas mal
das mulleres, que tan ben te queren e que te arrolan nas fiadas e nas
festas coma a fillo de rei e sabendo que ta nai foi muller, e que, si
ta nai non fora, ti non vieras  mundo coma cada un de tantos.

-Nin moito se perdera anque nunca ac chegara. Que mellor que sudando
polos camios pra ganar o pan de boca, e mellor que rechinar nas
festas e non nas festas, con menias que caras se venden sin valer un
chavo, engaando s homes, estara al na mente de Dios.

-Diancre de home!, que mesmo s veces penso se eres de aqueles que
sadan  crego slo por que non digan. E pois, ti es dono de decir
canto queiras, pro eu tamn che digo que me fai falta un acheguio, e
que me vou casare antes da festa, as Dios me d sade.

-E premita el Seore que non sudes moito, Xan, anque ora  inverno,
que entonces si que inda tusirs mis que eu cando de casar me
falan. E adivrtoche que teas tino de non matar carneiros na festa,
que  mal encomenzo pra un casado, por aquelo dos cornos retortos que
se guindan  p da porta, e xa se sabe que un mal tira por
outro. Diono libre!

-E ti qus saber que xa me van parecendo contos de vella eso que se
fala de cornos e de maldade das mulleres? Pois cando nesta nosa terra
se d en decir que un can rabiou, sea certo ou non sea certo, corre a
bla e mtase o can. Mais eu por min che aseguro que no atopei nunca
muller solteir que non se fixese mui rogada, nin casada que o seu home
comigo falase; e parseme que anda non fago tan mal rapaz, anque o
decilo sea fachenda.

- que eso vai no axeitarse, e ti seica no acertache, Xan; que 
demais coma un home queira, non queda can tras palleiro. Eu cho digo,
non hai neste mundo mis muller boa pra os homes que aquela que os
pariu, i as, arrenega de elas coma do demo, Xan, que a muller demo ,
segn di non sei que santo moi sabido; i o demo hastra  cruz lle fai
os cornos de lonxe.

-Volta cos cornos!

- tan sabido que si tanto mal che fai anomealos,  porque xa che dan
sombra dende o tellado da que a de ser ta muller.

-Seica me queres aqueloutrare! Pouco a pouco, Lourenzo, que nin debes
falar as de quen non conoces, nin tdaslas mulleres han de ter o ollo
alegre, que por moitas eu sei por quen se poidera poer, non unha,
senn cen vidas.

-O dito, dito queda, que cando eu falo  con concencia; e reptoche
que, sendo muller, non quedo por ningunha, anque sea condesa ou de
sangre nobre, como solen decir, que unhas e outras foron feitas da
mesma masa e coxean do mesmo p. Dios che mas libre do meu lar, que
ora no lar alleo anda nas cuspo.

-Ah! ladrn da honra allea, lveche o deo si eu quixera que cuspiras
na do meu, que o pensamento de que quizais terei que manter muller pra
un rabudo coma ti faime pr os cabelos dreitos e o entendimento
pensatible. Pro... falemos craros, Lourenzo, coma bos compaeiros que
somos. Ti es mis listo que eu, ben o vexo, e por donde andes sbeste
amaar que adimira, mentras que eu me quedo  p do lume vendo como o
pote ferve e cantan os grilos. Se conto, o conto vai no amao... pro
esto de que as has de botar todas nunha manada, sin deixar unha pra
min, vllanme tdolos santos que me fai suare. Vaia!, dime que anda
viches mulleres boas, e que non todas lle saben poer a un home
honrado os cornos na testa.

-Todas, Xan, todas; e pra os Xans anda mis; que mesmo pars que o
nome as atenta.

-Condenicado de min, que seique  certo! Pro meu pai e mia nai
casronse e ieu me quero casare, que mesmo se me van os ollos cando
vexo  anoitecido un matrimonio que fala pasenio sentado  porta da
eira, mentras corren os menios  luz do luar por embaixo das
figueiras.

- aire,  aire! E dixate de faladuras! Pasenio que pasenio,
tamn se dan beliscos e rabuadas, e pasenio se fan as figas.

-En verdade, malo me vai parecendo o casoiro, pro moito me temo que a
aficin non me faga prevaricare. Mais sempre que me case, caisareime
cunha do meu tempo, chea de carne, con xucio e facendosa, que poida
que neso no haxa tanto mal... Que me dis?

-Que es terco coma unha burra. Ti telo deo, Xan, i ora estache
facendo as cchegas co casoiro. Pro ten entendido que non hai volta
sinn que Diolo mande, que tratndose de aquelo da franqueza das
mulleres, todas deitan coma as cestas e cn coma si non tivesen ps.

As falando Xan e Lourenzo, iban chegando a cerca de un lugar. E como
xa de lonxe empezasen a sentir berros e choros, despois de un alto,
por saber o que al pasaba, viron que era un enterro, e a un rapaz que
via polo camino preguntronlle polo morto, e respondeulles que era un
home de unha muller que inda moza quedaba viuda e sin fillos que nunca
tivera, e que o morto non era nativo de aquela aldea, pro que tia
noutra hardeiros.

Foise o rapaz, e Lourenzo, chegndose a Xan, dxolle entonces:

-E ti qus, Xan, que che faga ver o que son as mulleres, que ora a
ocasin  boa?

-E pois como?

-Facendo que esa viuda, que non sei quen , nin vin na mia vida, me
d nesta mesma noite palabra de casamento pra de aqu a un mes.

-E ti ests cordo, Lourenzo?

-Mis que ti, Xan; qus ou non qus?

-E pois ben, tolo. Vamos a apostare, e si ganas perdo a mia mula
branca que herdei do meu pai logo far un ano, e que a estimo por esto
e por ser boa como as nias dos ollos. Curareime entonces do mal de
casoiro; pro si ti perdes, tes que mercar un farroupeiro e non volver
a falar mal das mulleres, mias xoias, que anda as quero mis que 
mia mulia branca.

-Apostado. Bixate, pois, da mula, e fai desde agora todo o que che eu
diga sin chistar, e hastra man pola fresca nin ti es Xan nin eu
Lourenzo, sinn que ti es meu criado i eu son teu amo. Agora ven tras
min tendo conta da mula, que eu irei diante, e di a todo amn.

Meu dito, meu feito.

Lourenzo tirou diante e Xan botou a p, indo detrs ca mula polas
bridas, que eran monas, as coma os demais arreos, e metan moita
pantalla.

 mesmo tempo que eles iban chegando  Campo Santo, ia chegando tamn
o enterro, rompendo a marcha o estandarte negro e algo furado da
parroquia, o crego i as mulleres que lle facan o pranto, turrando,
turrando polos pelos como si fosen cousa allea, berrando hastra
enroucare e agarrndose  tomba de tal maneira que non deixaban andar
s que a levaban.

-Ai, Antn! Antn! -deca unha pondose como a Madalena cas mans
cruzadas enriba da cabeza-. Antn, meu amigo, que sempre me decas:
Adis, Mariquia! cando me topabas no camio. Adis, Antn, que xa
non te verei mis!

I outra, indo arrastro atrs da caixa e pegando en s, desa tamn:

-En onde ests, Antn, que xa non me falas? Antn, malpocadio, que
che fixeron as mias ms uns calzs de lenzo cro e non os puxeches,
Antn; quen ha de pr agora a ta chaqueta nova i os teus calzs,
Antn?

I a viuda, i unhas sobrias da viuda, todas cubertas de bgoas,
vestidas de loito e os periquitos desfeitos de tanto turrar por eles,
e os panos desatados, berrando ainda mis; sobre todo a viuda, que
indo de cando en cando a meterse debaixo da mesma tomba, de donde a
tian que arrancar por forza, deca:

-Ai, meu to!1Ai, meu to, bonito como unha prata e roxio como un
ouro, que cedo che vai comela terra as tas carnias de manteiga! E
ti vaste, meu to! Ti vaste? E quen sera agora o meu acheguio, e
quen me dir como me decas ti, meu ben: Come, Margaridia, come pra
engordare, que o teu  meu, Margaridia, e si ti coxeas, tamn a min
me perece que estou coxo? Adis, meu to, que xa nunca mis
dormiremos xuntios nun leito! Quen me dera ir contigo na tomba,
Antn, meu to, que  fin contigo, mia xoa, entrrase meu corazn!

As a viudia se desdichaba seguindo  morto, cando de repente,
metndose Lourenzo entre as mulleres, cubertos os ollos cun pano e
saloucando como si lle sase da ialma, escramou berrando, anda mis
que as do pranto:

-Ai, meu to!, ai, meu to, que ora vexo ir mortio nesa tomba!
Nunca eu aqu viera pra non te atopar vivo, e non  polo testamento
que fixeches en favor meu deixndome por hardeiro, que sempre te
quisen como a pai, e esto que me habas de chamar para despedirte de
min e que te hei de ver xa morto, prteme as cordas do corazn. Ai,
meu to! ai, meu to!, que mesmo me morro ca pena.

Cando esto oron todas as do pranto, puxronse arredor de Lourenzo,
que mesmo se desfaca  ua de tanto dr como pareca ter.

-E logo ti como te chamas, meu fillo? -lle preguntaron moi
compadecidas de el.

-Eu chmome Andruco, e son sobrio do meu to, que me deixou por
hardeiro e me mandou chamare por unha carta pra se despedir de min
antes de morrer; pro, como tiven que andar moita terra, xa slo o podo
ver na tomba. Ai, meu to! Ai, meu to!

-E ti de onde es, mozo?

-Eu son da terra do meu to -volveu a desir Lourenzo, saloucando
hastra cortrselle a fala.

-E teu to de dnde era?

-Meu to era da mia terra.

E sin que o poideran quitar de esto, Lourenzo, proseguindo co pranto,
foise achegando  viudia, que, anda por entre as bgoas que a
curban, poido atisvare aquel mozo garrido que tanto choraba polo seu
to. Despois que se viron xuntos, logo lle dixo Lourenzo que era
hardeiro do difunto, i ela mirouno con moi bos ollos, e, acabado o
enterro, dxolle que tia que ir co ela  sa casa, que non era xusto
parase noutra o sobrio do seu home, e que as choraran xuntos a sa
disgrasia.

-Disgrasia moita. Ai, meu to! -dixo Lourenzo-; pro consoldevos, que
co que l me deixou conto facerlle decir moitas misas pola ialma, para
que el descanse e poidamos ter ns maior consolo ac na terra, que 
fin, a ta, Dios mndanos ter pacencia cos traballos, e... que
queiras que non queiras, como dixo o ioutro, a terria cai enriba dos
corpos mortos e... que hai que facer? Ns tamn temos que ir, que as
 o mundo.

As falando e chorando, tornaron camio da casa da viuda, e Xan, que
iba detrs ca mula e que nun principio non entendera nin chisca do que
quera facer Lourenzo, comenzou a enxergare e pasoulle as, polas
carnes unha especie de escallofro, pensando en si ira a perder a sa
mula branca. Anque, a ver o dor e as bgoas da viudia, que non lle
deixaban de correr a fo pola cara afrixida, volveu a ter confianza en
Dios e nas mulleres, a quen tan ben quera.

-E vs, a ta, ters un sitio pra meter esta mula i o meu criado,
que un e outro de tanto camiare veen cansados coma raposos?

-Todo terei pra vs, sobrio do meu to, que mesmo con vervos pareceme
que o estou vendo e srveme de moito consolo.

-Dencho ca viudia, os consolos que atopa! -marmurou Xan pra si
metendo a mula no pesebre. Pro de esto a casarse -aadeu, contento de
si mesmo-, anda hai la mare.

E co esta espranza pxose a comer con moitas ganas un bo anaco de
lacn que a viuda lle deu, mollndoo co unha cunca de vio do Ribeiro
que arda nun candil e que lle alegrou a pestana, mentras ta e
sobrio estaban al enriba no sobrado, falando da herencia e do morto
cos que os acompaaban.

De esta maneira pasouse o da e chegou a noite, e quedaron solos na
casa a viuda, Lourenzo e Xan, que desque viu cerrar as portas estuvo 
axexa, co corazn posto na mulia branca, a ialma en Lourenzo e a
espranza en Dios, que non era pra menos. E, non sin pena, veu coma a
viudia e Lourenzo foron ceando, antre as bgoas, uns bocados de porco
e de vaca que puan medo s cristianos e uns xarros de vio que foran
capaces de dar nimos  peito mis angustiado. Pro  mesmo tempo nada
se falaba do particulare, e Xan non poda adiviare como se axeitara
Lourenzo, pra ganar a aposta, que va por sa.

 fin trataron de se ir deitar, e a Xan puxronselle os cabelos
dreitos cando veu que en toda a casa non haba mis que a cama do
matrimonio, e que a viudia tanto petelescou pra que Lourenzo se
deitase nela que aqul tivo que obedecer, indo ela, envolta nun
mantelo, a meterse detrs de un trabado que no sobrado haba.

Xan, ca ialma nun fo, viu, desde o faiado, donde lle votaron unhas
pallas, coma a viudia matou o candil e todo quedou s escuras.

-Seica quedars comigo, mia mulia branca, i abof que te vin perdida
-escramou entonces-;  fin as mulleres foron feitas de unha nosa
costilla e algo han de ter de bo. Slvame, viudia, slvame de este
apreto, que inda serei capaz de me casar contigo.

Deste modo falaba Xan pra si, anque  mesmo tempo non poda cerrar
ollo, que a cada paso lle pareca que ruxan as pallas.

As pasou unha hora longa, en que Xan, contento, xa iba a dormir,
descoidado, cando de pronto oieu, primeiro un sospiro, e despois
outro, cal si aqueles sospiros fosen de alma do outro mundo;
estremeceuse Xan e ergueuse pra escoitar mellore.

-Ai!, meu to!, meu to! -dixo entonces a viudia; que fra estou
neste taboado, pro mis fro ests, ti, meu to, nesa terria que te
vai comere!

-Ai, meu to!, meu to! -escramou Lourenzo da outra banda, como si
falase consigo mesmo-; canto me acordo de ti, que estou no quente, e
ti no Campo Santo, nun leito de terra donde xa non tes compaa.

-Ai! Antoncio! -volveu a decir a viuda-, que ser de ti naquel
burato, meu queridio, cando eu que estou baixo cuberto...!, bu, bu,
bu!... qu fro va!, tembro como si tuvese a perlesa!, bu, bu,
bu!...

-Mia ta!

-E seica non dormes, meu sobrio?

-E seica vs tampouco, a ta, que vos sento tembrare como unha vara
verde.

-Como qus ti que durma, acordndome nesta noite de xiada do teu to,
que ora dorme no Campo Santo, fro como a neve, cando si el vivira
dormiramos ambos quentios nese leito donde ti ests?

-E non podiades vs poervos aqu nun ladio, anque fora envolta no
mantelo coma estades, e anda mis habendo necesid como agora, xa que
non queres que eu vaia dormir  chan, que mesmo pode darvos un frato
co dr e co fro, i  pecado, a ta, tentar contra a sade?

-Deixa, meu fillo, deixa; que aunque penso que mal no houbera en que
eu me deitase  lado de un sobrio como ti, envolta no mantelo e por
riba da roupa, estanto como estoxi tembrando, bu, bu, bu!... qurome
ir afacendo, que moitas de estas noites han de vir pra min no mundo,
que si antes fora rica e casada agora son viuda e probe; e canto tiven
meu agora teu , que a min non me queda mis que o ceo i a terra.

-E... pois, mia ta... Aqu pra entre dous pecadores, e sin que naide
nos oia mis que Dios, vouvos a decire que eu sei de un home rico e da
sangre do voso difuntio que, si vs quixrades, tomaravos por
muller.

-Cala, sobrio, e no me fales de outro home... que inda pars que o
que tiven est vivo.

-Deix, mia ta, que as non perderedes nin casa, nin leito, nin
facenda, que  moito perder de unha vez, sin contar co meu to; a quen
lle hei de dicir moitas misas, como das ten o ano, pra que descanse e
non vos vea a chamar nas noites de inverno. As el estar al ben, e
vs aqu; e si el vivira, non outra cousa vos aconsellara, senn que
tomrades outra ves home da sa sangre, a quen lle deixou o que l e
vs comchedes xuntos na sa vida.

-E seica tes razn, meu sobrio, pro... si este era o teu pensamento,
Antn, meu to!, por que non mo dixeche antes de morrer, que entonces
eu o fixera anque fora contra voluntade, slo por te servire?

-Pola mia conta, a ta, que si meu to nada vos dixo, foi porque se
lle esquenceu co conto das agonas, e non vos estrae, que a calquera
lle pasara outro tanto.

-Tes razn, tes; a morte  moi negra e naquela hora todo se
esquence. Ai!, meu to!, meu to! Que non fixera eu por che dar
gusto?, bu, bu, bu!... que fro vai!

-Vinde pra aqu, que, si non vos asas, direivos que eu son o que vos
quer por muller.

-Ti que me dis, home? Pro,  ver que o adiviei logo; que slo un
sobrio do meu to lle quixera cumprir as a voluntade...

-Pro  ser, tia que ser de aqu a un mes, que despois teo que ir a
Cais en busca de outra herencia, e quixera que antes quedrades outra
vez dona do que foi voso. O que ha de ser, sea logo, que  fin meu to
haio de estar deseando desde a tomba.

-Ai!, meu to!, meu to!, que sobrio che dou Dios, que mesmo de
olo parceme que te estou ondo; pro... meu fillo...  anda moi
cedo, e anque ti mis eu nos volvramos a casar ca intencin de lle
facer honra e recordar  difunto, o mundo murmura... e...

-Deixvos do mundo, que casaremos en secreto e naide o saber.

-E pois ben, meu sobrio, e slo pro que es da sangre do meu to, e xa
que me dis que se ha de alegrar na tomba de vernos xuntos... co
demis... ai!, Dios me valla... eu queralle moito a meu to! Bu,
bu, bu!... como xa!

-Vinde pra onda min envolta no mantelo, que non  pecado xa que habs
de ser mia muller.

-Pro... anda non a son, menio, e teo remorsos... Bu, bu, bu!, que
frato me d pola cabeza e polo corazon.

-a ta, vinde e deixvos de atentar contra a sade, que se al
pecsedes, antes de casar tmonos que confesare.

-Irei, logo... irei, que necesito un pouco de calorio.

Entonces sintronse pasadas, ruxiron as pallas, e a viuda escramou con
moita dolore:

-Ai, mia Virxen do Carmen, que axia te ofendo!

-Ai, mia mulia branca, que axia te perdo! -marmurou entonces Xan,
con sentimento e con coraxe. E chegndose enseguida  porta do
sobrado, berrou con forza:

-Meu amo, a casa arde!

-Non arde, home, non, que  rescoldo.

-Pois rescoldo ou la, si agora non vindes voume ca mula.

E Lourenzo, saltando de un golpe  chan, dixo:

-Agarda logo... Esperaime, a ta, que logo volvo.

E hai cen anos que foi esto, e anda hoxe espera a viuda polo sobrio
do seu to.


